%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                %
%          MatLab GUI dialog for showing about dialog            %
%                                                                %
%          Function: about_links                                 %
%                                                                %
%          Input:                                                %
%                       mytext: text string                      %
%          		          myimage: image name                      %
%                       mylabel: text string                     %
%                       thisheight: height of dialogue           %
%                                                                %
%          Output:                                               %
%          		          none                                     %
%                                                                %
%          This version:        May 3, 2006                      %
%          Written by: 	        Anders Warne                     %
%                               Copyright (c) 2001-2006          %
%                                                                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function about_links(mytext,myimage,url,email,mylabel,thisheight,width);

if nargin==2;
   url = '';
   email = '';
   selector = 'init';
   mylabel = 'About';
elseif nargin==3;
   email = '';
   selector = 'init';
   mylabel = 'About';
elseif nargin==4;
   selector = 'init';
   mylabel = 'About';
elseif nargin==5;
   selector = 'init';
elseif nargin==6;
   selector = 'init';
elseif nargin==7;
   selector = 'init';
else;
   selector = 'ok';
end;

if nargin<6;
   thisheight = 124;
else;
   if isnumeric(thisheight)==0;
      thisheight = 124;
   end;
end;

if nargin<7;
   width = 272;
else;
   if isnumeric(width)==0;
      width = 272;
   end;
   if width<250;
      width = 250;
   end;
end;

textheight = thisheight-54;
axesheight = (thisheight-90)/2;
if axesheight<0;
   axesheight = 0;
end;

if strcmp(selector,'init')==1;
   mycons = getstoredimages;
   curr_ini = find_inisettings;
   if curr_ini.use_toolbar_bgcolor==1;
      bgcolor = (1/255)*(round(255*get(0,'defaultuicontrolbackgroundcolor'))-[8 4 8]);
      bgcolor(1) = max(0,bgcolor(1));
      bgcolor(2) = max(0,bgcolor(2));
      bgcolor(3) = max(0,bgcolor(3));
   else;
      bgcolor = get(0,'defaultuicontrolbackgroundcolor');
   end;
   %
   if strcmp(myimage,'information')==1;
      mylogo = mycons.information_image;
   elseif strcmp(myimage,'question')==1;
      mylogo = mycons.question_image;
   elseif strcmp(myimage,'warning')==1;
      mylogo = mycons.warning_image;
   elseif strcmp(myimage,'error')==1;
      mylogo = mycons.error_image;
   elseif strcmp(myimage,'borg')==1;
      mylogo = mycons.borg_image;
   elseif strcmp(myimage,'bootstrap')==1;
      mylogo = mycons.bootstrap_image;
   elseif strcmp(myimage,'figeditor')==1;
      mylogo = mycons.figeditor_image;
   elseif strcmp(myimage,'internet')==1;
      mylogo = mycons.internet_image;
   else;
      mylogo = mycons.logo_image;
   end;
   mylogo = maketrans(mylogo,[160 160 164],bgcolor);
   mylogo = mirrorimage(mylogo);
   thisexit = 0;
else;
   thisexit = 1;
   aboutdlg = get(0,'CurrentFigure');
   myabout = get(aboutdlg,'UserData');
end;

scrsz = get(0,'ScreenSize');

cu_ini = find_inisettings;

switch selector;
   case 'init';
      aboutdlg = figure('Color',get(0,'defaultuicontrolbackgroundcolor'), ...
         'FileName','about_links.m', ...
         'MenuBar','none', ...
         'Units','pixels', ...
         'Position',[(scrsz(3)-width)/2 (scrsz(4)-thisheight)/2 width thisheight], ...
         'Tag','FigAboutLinks', ...
         'Resize','off', ...
         'DoubleBuffer','on', ...
         'Visible','off', ...
         'Name',mylabel, ...
         'NumberTitle','off', ...
         'CloseRequestFcn','about_links ok', ...
         'WindowButtonMotionFcn','show_links', ...
         'WindowButtonDownFcn','run_links', ...
         'WindowStyle','modal', ...
         'ToolBar','none');

      if matlabnumber>=7.0;
         set(aboutdlg,'DockControl','off');
      end;

      imageaxes = axes('Units','pixels', ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'CameraUpVector',[0 1 0], ...
         'Color',get(0,'defaultuicontrolbackgroundcolor'), ...
         'Position',[10 50+axesheight 39 39], ...
         'XTickLabelMode','manual', ...
         'YTickLabelMode','manual', ...
         'Tag','AxisLogo', ...
         'XColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'YColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ZColor',get(0,'defaultuicontrolbackgroundcolor'));

      image('CData',mylogo,'Clipping','off','Parent',imageaxes);

      if isempty(url)==0;
         mytext = strvcat(mytext,'Web site:');
      end;
      if isempty(email)==0;
         mytext = strvcat(mytext,'Email:');
      end;

      bg_axes = axes('Units','pixels', ...
         'Position',[50 50 width-52 textheight], ...
         'Tag','bg_axes', ...
         'Color',[1 1 1], ...
         'XColor',[1 1 1], ...
         'YColor',[1 1 1], ...
         'Box','on', ...
         'Visible','off', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1]);

      myabout.icon = text('Parent',bg_axes, ...
            'Interpreter','none', ...
            'Units','pixels', ...
            'Clipping','on', ...
            'VerticalAlignment','bottom', ...
            'HorizontalAlignment','left', ...
            'Position',[5 5], ...
            'String',mytext, ...
            'Editing','off', ...
            'Visible','on', ...
            'Tag','BackText', ...
            'FontSize',cu_ini.gui_fontsize, ...
            'FontName',cu_ini.gui_fontname, ...
            'FontWeight',cu_ini.gui_fontweight, ...
            'FontAngle',cu_ini.gui_fontangle);

      if isempty(url)==0;

         url_axes = axes('Units','pixels', ...
            'Position',[100 68 width-182 15], ...
            'Tag','url_axes', ...
            'Color',[1 1 1], ...
            'XColor',[1 1 1], ...
            'YColor',[1 1 1], ...
            'Box','on', ...
            'Visible','off', ...
            'TickLength',[0 0], ...
            'XTickLabel',[], ...
            'YTickLabel',[], ...
            'XTick',[0 1], ...
            'YTick',[0 1]);

         url_text = text('Parent',url_axes, ...
               'Interpreter','none', ...
               'Units','pixels', ...
               'Clipping','on', ...
               'VerticalAlignment','bottom', ...
               'HorizontalAlignment','left', ...
               'Position',[5 0], ...
               'String',url, ...
               'Editing','off', ...
               'Color',[0 0 1], ...
               'Visible','on', ...
               'Tag','url', ...
               'FontSize',cu_ini.gui_fontsize, ...
               'FontName',cu_ini.gui_fontname, ...
               'FontWeight',cu_ini.gui_fontweight, ...
               'FontAngle',cu_ini.gui_fontangle);

         set(url_axes,'UserData',url_text);

      end;

      if isempty(email)==0;

         email_axes = axes('Units','pixels', ...
            'Position',[100 53 width-182 15], ...
            'Tag','email_axes', ...
            'Color',[1 1 1], ...
            'XColor',[1 1 1], ...
            'YColor',[1 1 1], ...
            'Box','on', ...
            'Visible','off', ...
            'TickLength',[0 0], ...
            'XTickLabel',[], ...
            'YTickLabel',[], ...
            'XTick',[0 1], ...
            'YTick',[0 1]);

         email_text = text('Parent',email_axes, ...
               'Interpreter','none', ...
               'Units','pixels', ...
               'Clipping','on', ...
               'VerticalAlignment','bottom', ...
               'HorizontalAlignment','left', ...
               'Position',[5 2], ...
               'String',email, ...
               'Editing','off', ...
               'Color',[0 0 1], ...
               'Visible','on', ...
               'Tag','email', ...
               'FontSize',cu_ini.gui_fontsize, ...
               'FontName',cu_ini.gui_fontname, ...
               'FontWeight',cu_ini.gui_fontweight, ...
               'FontAngle',cu_ini.gui_fontangle);

         set(email_axes,'UserData',email_text);

      end;

      myabout.ok = uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'Position',[(width-50)/2 12 50 25], ...
         'String','OK', ...
         'FontSize',cu_ini.gui_fontsize, ...
         'FontName',cu_ini.gui_fontname, ...
         'FontWeight',cu_ini.gui_fontweight, ...
         'FontAngle',cu_ini.gui_fontangle, ...
         'Enable','on', ...
         'Callback','about_links ok', ...
         'UserData','waiting', ...
         'Tag','Button');

      set(aboutdlg,'UserData',myabout,...
         'HandleVisibility','callback');

   case 'ok'
      set(myabout.ok,'UserData','done');
      delete(aboutdlg);
      drawnow;
end;

if thisexit==0;
   if (iswinnt==1)&(iscompiled==1)&(curr_ini.noicon==1);
      set(aboutdlg,'WindowStyle','normal');
      prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(aboutdlg,'Name') ' NULL'];
      dos(prog);
      wait_fcn(curr_ini.delay);
      pos = get(aboutdlg,'Position');
      set(aboutdlg,'Position',[0 0 1 1]);
   end;
   %
   set(aboutdlg,'Visible','on');
   drawnow;
   if (iswinnt==1)&(iscompiled==1)&(matlabnumber<7);
      if curr_ini.noicon==1;
         drawnow;
         set(aboutdlg,'WindowStyle','modal');
         prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(aboutdlg,'Name') ' NULL'];
         dos(prog);
         wait_fcn(curr_ini.delay);
         set(aboutdlg,'Position',pos);
      end;
      %
      drawnow;
      prog = ['bin\run_prog.exe ' fix_path([pwd '\bin\setfocus.exe']) ' ' get(aboutdlg,'Name') ' 1'];
      dos(prog);
      drawnow;
      if curr_ini.noicon==1;
         set(aboutdlg,'Position',pos);
      end;
   elseif matlabnumber>=7;
      %
      % set focus on OK button
      %
      uicontrol(myabout.ok);
   end;
   waitfor(myabout.ok,'UserData','done');
end;

%
% end of about_links.m
%