function [alpha,stat] = alpha_rank_rnd(Z0,Z1,Z2,D,n,r,Omega,delta,Gamma,beta,lambda_alpha,cu_symmetric)

Z = Z0;
if isempty(delta)==0;
   Z = Z-(delta*D);
end;
if isempty(Gamma)==0;
   Z = Z-(Gamma*Z2);
end;

%
% compute the mean and covariance for alpha conditional on
% beta, delta, Gamma, Omega, and the data
%

cov_mat = beta'*( Z1*Z1' + ((1/(lambda_alpha^2))*eye(n)) )*beta;
mean_vec = Z*Z1'*beta*inverse(cov_mat);
mean_vec = vec(mean_vec);

cov_mat = kron(inverse(cov_mat),Omega);

[std_mat,stat] = chol(cov_mat);
if stat>0;
   alpha = [];
   return;
end;
if cu_symmetric==1;
   std_mat = symm(cov_mat);
end;

alpha_vec = mean_vec+(std_mat'*randn(n*r,1));
alpha = vecinv(alpha_vec,n);

%
% end of alpha_rank_rnd.m
%
