function [alpha,stat] = alpha_rnd(Z0,Z1,Z2,D,n,r,Omega,delta,Gamma,beta,lambda_alpha,cu_symmetric,prior_inf_alpha)

Z = Z0;
if isempty(delta)==0;
   Z = Z-(delta*D);
end;
if isempty(Gamma)==0;
   Z = Z-(Gamma*Z2);
end;

%
% compute the mean and covariance for alpha conditional on
% beta, delta, Gamma, Omega, and the data
%

if prior_inf_alpha==1;
   cov_mat = beta'*( Z1*Z1' + ((1/(lambda_alpha^2))*eye(n)) )*beta;
else;
   cov_mat = beta'*Z1*Z1'*beta;
end;
mean_vec = Z*Z1'*beta*inverse(cov_mat);
mean_vec = vec(mean_vec);

cov_mat = kron(inverse(cov_mat),Omega);

%cov_mat = kron((beta'*Z1*Z1'*beta),inverse(Omega));
%mean_vec = vec(inverse(Omega)*Z*Z1'*beta);
%
%if prior_inf_alpha==1;
%   A_sigma = kron(beta'*beta,((1/(lambda_alpha^2))*inverse(Omega)));
%   cov_mat = cov_mat+A_sigma;
%end;
%
%old_cov_mat = cov_mat;
%cov_mat = inverse(cov_mat);
%mean_vec = cov_mat*mean_vec;

[std_mat,stat] = chol(cov_mat);
if stat>0;
   alpha = [];
   return;
end;
if cu_symmetric==1;
   std_mat = symm(cov_mat);
end;

alpha_vec = mean_vec+(std_mat'*randn(n*r,1));
alpha = vecinv(alpha_vec,n);

%
% end of alpha_rnd.m
%
