%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                %
%          MatLab GUI dialog for showing combo box               %
%                                                                %
%          Function: combodlg                                    %
%                                                                %
%          Input:                                                %
%                       mychoices: text string                   %
%                       myvalue: current item on string          %
%                       myname: name for combo box window        %
%                       mylabel: text string                     %
%                       mylabelsize: interger                    %
%                       mytext: text string                      %
%                                                                %
%          Output:                                               %
%          	            action: OK or Cancel                     %
%                       selection: selected item                 %
%                                                                %
%          This version:        April 4, 2006                    %
%          Written by: 	        Anders Warne                     %
%                               Copyright (c) 2001-2006          %
%                                                                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [action,selection] = combodlg(mychoices,myvalue,myname,mylabel,mylabelsize,mytext)

scrsz = get(0,'ScreenSize');
curr_ini = find_inisettings;

combogui = figure('Color',get(0,'defaultuicontrolbackgroundcolor'), ...
   'FileName','combodlg.m', ...
   'MenuBar','none', ...
   'Units','pixels', ...
   'Position',[scrsz(3)/2-150 (scrsz(4)-110)/2 300 110], ...
   'Tag','FigSheetDlg', ...
   'Resize','off', ...
   'Name',myname, ...
   'Visible','off', ...
   'NumberTitle','off', ...
   'WindowStyle','modal', ...
   'CloseRequestFcn','closegui', ...
   'ToolBar','none');

if matlabnumber>=7.0;
   set(combogui,'DockControl','off');
end;

axesbox([2 2 298 103],mylabel,mylabelsize,[0.5 1]);

uicontrol('Units','pixels', ...
   'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
   'Position',[12 70 270 20], ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'Style','text', ...
   'HorizontalAlignment','left', ...
   'String',mytext, ...
   'Tag','Text');

combos.select = uicontrol('Units','pixels', ...
   'BackgroundColor',[1 1 1], ...
   'Position',[12 50 276 20], ...
   'Value',myvalue, ...
   'String',mychoices, ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'Style','popupmenu', ...
   'Enable','on', ...
   'Tag','ComboPopup');

%
% Two buttons to select action
%

combos.ok = uicontrol('Units','pixels', ...
   'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
   'Position',[98 12 50 25], ...
   'String','OK', ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'Enable','on', ...
   'Callback','closegui', ...
   'UserData','waiting', ...
   'Tag','ButtonOK');

combos.cancel = uicontrol('Units','pixels', ...
   'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
   'Position',[152 12 50 25], ...
   'String','Cancel', ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'Enable','on', ...
   'Callback','closegui', ...
   'Tag','Buttoncancel');

if (iswinnt==1)&(iscompiled==1)&(curr_ini.noicon==1);
   set(combogui,'WindowStyle','normal');
   prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(combogui,'Name') ' NULL'];
   dos(prog);
   wait_fcn(curr_ini.delay);
   pos = get(combogui,'Position');
   set(combogui,'Position',[0 0 1 1]);
end;
set(combogui,'Visible','on');
drawnow;
if (iswinnt==1)&(iscompiled==1);
   if curr_ini.noicon==1;
      drawnow;
      set(combogui,'WindowStyle','modal');
      prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(combogui,'Name') ' NULL'];
      dos(prog);
      wait_fcn(curr_ini.delay);
      set(combogui,'Position',pos);
   end;
   drawnow;
   if matlabnumber<7;
      prog = ['bin\run_prog.exe ' fix_path([pwd '\bin\setfocus.exe']) ' ' get(combogui,'Name') ' 2'];
      dos(prog);
      drawnow;
   elseif matlabnumber>=7;
      uicontrol(combos.ok);
   end;
   if curr_ini.noicon==1;
      set(combogui,'Position',pos);
   end;
end;
waitfor(combogui,'waitstatus','inactive');
%uiwait(combogui);

action = get(get(combogui,'CurrentObject'),'String');

if isempty(action)==1;
   action = 'Cancel';
end;

selection = get(combos.select,'Value');

delete(combogui);
drawnow;

%
% end of combodlg.m
%
