function [correps,stdeps] = correlate(epsilon)

%
% regresses epsilon on floor(T/6) lags
%

[n T] = size(epsilon);
if n>T;
   epsilon = epsilon';
   [n T] = size(epsilon);
end;

lags = floor(T/6);

y = epsilon(:,lags+1:T);

x = [];
for i=1:lags;
   x = [x;epsilon(:,lags+1-i:T-i)];
end;

correps = (y*x')/(x*x');
eta = y-correps*x;
sigma = (1/(T-lags))*eta*eta';
inv_x = eye(size(x,1))/(x*x');
stdeps = sqrt(diag(sigma*inv_x))';

%
% end of correlate.m
%
