function h = disptext(txt_str,curr_axes)

if nargin==1;
   curr_axes = gca;
end;

old_units = get(curr_axes,'Units');
set(curr_axes,'Units','pixels');
ax_pos = get(curr_axes,'Position');

ax_obj = axes('Units','pixels', ...
   'TickLength',[0 0], ...
   'CameraUpVector',[0 1 0], ...
   'Color',[1 1 1], ...
   'Box','on', ...
   'Position',ax_pos, ...
   'XTickLabelMode','manual', ...
   'YTickLabelMode','manual', ...
   'Tag','BGText', ...
   'Visible','off', ...
   'XColor',[0 0 0], ...
   'YColor',[0 0 0], ...
   'ZColor',[0 0 0]);

txt_obj = text('Units','pixels', ...
               'String',txt_str, ...
               'FontSize',5, ...
               'FontName',get(0,'FixedWidthFontName'), ...
               'Visible','off', ...
               'HorizontalAlignment','left', ...
               'Parent',ax_obj);

set(ax_obj,'UserData',txt_obj);

%
% Create a context menu for the axes object
%

res_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
uimenu('Parent',res_context_menu,'Label','Delete','Callback','delete(get(gca,''UserData'')); delete(gca)');
set(ax_obj,'UIContextMenu',res_context_menu);
set(txt_obj,'UIContextMenu',res_context_menu);

%
% determine needed size of text, adjust axes and text positions
% and make visible
%

txt_ext = get(txt_obj,'Extent');
width = txt_ext(3)+10;
height = txt_ext(4)+10;
set(ax_obj,'Position',[ax_pos(1)+10 ax_pos(2)+ax_pos(4)-height-10 width height],'Visible','on');
set(txt_obj,'Position',[7.5 height/2+2.5],'Visible','on');

set(curr_axes,'Units',old_units);

if nargout==1;
   h = [ax_obj txt_obj];
end;

%
% end of disptext.m
%
