%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                %
%          MatLab GUI dialog for showing spreadsheet choices     %
%                                                                %
%          Function: editdlg                                     %
%                                                                %
%          Input:                                                %
%                       my_title: string                         %
%                       my_label: string                         %
%                       my_text: string                          %
%                                                                %
%          Output:                                               %
%          	            action: OK or Cancel                     %
%                       this_name: string                        %
%                                                                %
%          This version:        April 4, 2006                    %
%          Written by: 	        Anders Warne                     %
%                               Copyright (c) 2001-2006          %
%                                                                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [action,this_name] = editdlg(my_title,my_label,my_text)

%
% initialize
%

if nargin==0;
   my_title = 'Text Dialogue';
   my_label = 'Enter Text:';
   my_text = 'text';
elseif nargin==1;
   if isstr(my_title)==0;
      my_title = 'Text Dialogue';
   end;
   my_label = 'Enter Text:';
   my_text = 'text';
elseif nargin==2;
   if isstr(my_title)==0;
      my_title = 'Text Dialogue';
   end;
   if isstr(my_label)==0;
      my_label = 'Enter Text:';
   end;
   my_text = 'text';
else;
   if isstr(my_title)==0;
      my_title = 'Text Dialogue';
   end;
   if isstr(my_label)==0;
      my_label = 'Enter Text:';
   end;
   if isstr(my_text)==0;
      my_text = 'text';
   end;
end;

scrsz = get(0,'ScreenSize');
curr_ini = find_inisettings;

editgui = figure('Color',get(0,'defaultuicontrolbackgroundcolor'), ...
   'FileName','editdlg.m', ...
   'MenuBar','none', ...
   'Units','pixels', ...
   'Position',[scrsz(3)/2-150 (scrsz(4)-110)/2 300 110], ...
   'Tag','FigeditDlg', ...
   'Resize','off', ...
   'Name',my_title, ...
   'Visible','off', ...
   'NumberTitle','off', ...
   'WindowStyle','modal', ...
   'CloseRequestFcn','closegui', ...
   'ToolBar','none');

if matlabnumber>=7.0;
   set(editgui,'DockControl','off');
end;

%axesbox([2 2 398 83],'Sheet Selection',78,[0.5 1]);

uicontrol('Units','pixels', ...
   'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
   'Position',[12 75 88 20], ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'Style','text', ...
   'HorizontalAlignment','left', ...
   'String',my_label, ...
   'Tag','Text');

edits.edit = uicontrol('Units','pixels', ...
   'BackgroundColor',[1 1 1], ...
   'Position',[12 50 276 25], ...
   'Value',1, ...
   'String',my_text, ...
   'Style','edit', ...
   'HorizontalAlignment','left', ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'Enable','on', ...
   'Tag','EditEdit');

%
% Two buttons to select action
%

edits.ok = uicontrol('Units','pixels', ...
   'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
   'Position',[97.5 12 50 25], ...
   'String','OK', ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'Enable','on', ...
   'Callback','closegui', ...
   'UserData','waiting', ...
   'Tag','ButtonOK');

edits.cancel = uicontrol('Units','pixels', ...
   'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
   'Position',[152.5 12 50 25], ...
   'String','Cancel', ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'Enable','on', ...
   'Callback','closegui', ...
   'Tag','ButtonCancel');

if (iswinnt==1)&(iscompiled==1)&(curr_ini.noicon==1);
   set(editgui,'WindowStyle','normal');
   prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(editgui,'Name') ' NULL'];
   dos(prog);
   wait_fcn(curr_ini.delay);
   pos = get(editgui,'Position');
   set(editgui,'Position',[0 0 1 1]);
end;
set(editgui,'Visible','on');
drawnow;
if (iswinnt==1)&(iscompiled==1);
   if curr_ini.noicon==1;
      drawnow;
      set(editgui,'WindowStyle','modal');
      prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(editgui,'Name') ' NULL'];
      dos(prog);
      wait_fcn(curr_ini.delay);
      set(editgui,'Position',pos);
   end;
   drawnow;
   if matlabnumber<7;
      prog = ['bin\run_prog.exe ' fix_path([pwd '\bin\setfocus.exe']) ' ' get(editgui,'Name') ' 2'];
      dos(prog);
      drawnow;
   else;
      uicontrol(edits.ok);
   end;
   if curr_ini.noicon==1;
      set(editgui,'Position',pos);
   end;
end;
waitfor(editgui,'waitstatus','inactive');
%uiwait(editgui);

action = get(get(editgui,'CurrentObject'),'String');

if isempty(action)==1;
   action = 'Cancel';
end;

if strcmp(action,'Cancel')==0;
   this_name = get(edits.edit,'String');
else;
   this_name = '';
end;

delete(editgui);
drawnow;

%
% end of editdlg.m
%
