function fitted_terms(Z_0,Z_1,Z_2,mytheta,mybeta,p,d,origname,freq,samplebeg,sampleend,outputdir)

curr_ini = initialize_inifile;
[read_status,curr_ini] = read_inifile;
if read_status==1;
   curr_ini = initialize_inifile;
end;

if isnumeric(curr_ini.external)==0;
   curr_ini.external = 0;
end;
if curr_ini.colors==1;
   colorstr = 'b';
   colorstr2 = 'r';
   typestr = '-';
else;
   colorstr = 'k';
   colorstr2 = [0.5 0.5 0.5];
   typestr = '--';
end;
%
% setting up the actual sample period
%
dataindex = make_dataindex(freq,samplebeg,sampleend);
%
% preliminaries
%

namevector = vecstr(origname);

[n T] = size(Z_0);
if isempty(mybeta)==0;
   r = size(mybeta,2);
else;
   r = 0;
end;
if d>0;
   Z_2_deter = Z_2(1:d,:);
   Z_0_corr = Z_0-((Z_0*Z_2_deter'/(Z_2_deter*Z_2_deter'))*Z_2_deter);
else;
   Z_2_deter = [];
   Z_0_corr = Z_0;
end;

if p>1;
   Gamma_endo = mytheta(:,d+1:n*(p-1)+d);
   Z_2_endo = Z_2(d+1:n*(p-1)+d,:);
else;
   Gamma_endo = [];
   Z_2_endo = [];
end;
n2 = size(mytheta,2);
myalpha = mytheta(:,n2-r+1:n2);

diff_vars = [];
if p>1;
   for j=1:n;
      for i=1:n;
         diff_varsi = 0;
         for k=1:p-1;
            i1 = i+(k-1)*n;
            diff_varsi = diff_varsi+(Gamma_endo(j,i1)*Z_2_endo(i1,:));
         end;
         diff_vars = [diff_vars;diff_varsi];
      end;
   end;
end;

if d>0;
   diff_vars = diff_vars-((diff_vars*Z_2_deter'/(Z_2_deter*Z_2_deter'))*Z_2_deter);
end;

if r>0;
   coint_rel = mybeta'*Z_1;
   coint_vars = [];
   for j=1:n;
      for i=1:r;
         coint_vars = [coint_vars;myalpha(j,i)*coint_rel(i,:)];
      end;
   end;
   if d>0;
      coint_vars = coint_vars-((coint_vars*Z_2_deter'/(Z_2_deter*Z_2_deter'))*Z_2_deter);
   end;
end;

%
% setting up the graphs
%

num_cols = floor(sqrt(n));
num_rows = ceil(n/num_cols);
if num_cols*num_rows<n;
   num_rows = num_rows+1;
end;
realscrsz = get(0,'ScreenSize');
%width = min(num_cols*350,realscrsz(3));
%height = min(num_rows*0.7*350,realscrsz(4));
%width = min(num_rows*350,realscrsz(3));
width = min(num_cols*500,realscrsz(3));
height = min((realscrsz(4)/realscrsz(3))*(width-100),realscrsz(4));

%
% first difference terms
%

file_names = '';
stats = [];

thispos = [(realscrsz(3)-width)/2-22 (realscrsz(4)-height)/2+22];
for j=1:n;
   if p>1;
      diff_series = diff_vars(1+((j-1)*n):j*n,:);
      endo_series = Z_0_corr(j,:);
      %
      % fixing the position
      %
      thispos = [thispos(1,1)+22 thispos(1,2)-22];
      if thispos(1,1)>(realscrsz(3)-width);
         thispos = [0 realscrsz(4)-height];
      end;
      if thispos(1,2)>(realscrsz(4)-height);
         thispos = [0 realscrsz(4)-height];
      elseif thispos(1,2)<32;
         thispos = [0 realscrsz(4)-height];
      end;
      myplot = figure('Position',[thispos width height], ...
         'NumberTitle','off', ...
         'Visible','off', ...
         'Name',[strtrim(namevector(j,:)) ' and fitted lagged first difference terms']);
      %
      % obey centering and filling defaults
      %
      setfigureproperties(myplot);
      %
      %
      % Setting up the sub plots
      %
      axeshandles = [];
      for i=1:n;
         subplot(num_rows,num_cols,i);
         plot(dataindex,endo_series','-','LineWidth',1,'Color',colorstr);
         hold('on');
         plot(dataindex,diff_series(i,:)',typestr,'LineWidth',1,'Color',colorstr2);
         hold('on');
         plot(dataindex,zeros(T,1),'-','LineWidth',1,'Color','k');
         set(gca,'XLim',[dataindex(1,1) dataindex(size(dataindex,1),1)]);
         setaxesfonts('Title',['\Delta' strtrim(namevector(j,:)) ' and fitted terms for lagged \Delta' strtrim(namevector(i,:))]);
         myleg = legend_fcn(['\Delta ' strtrim(namevector(j,:))],['Lagged \Delta' strtrim(namevector(i,:))],2);
         setaxesfonts(myleg);
         set(gca,'UserData',myleg);
         axeshandles = [axeshandles gca];
         hold('off');
      end;
      toolbar_fcn(axeshandles);
      %
      % take care of automatically saving the graphs
      %
      if curr_ini.external==0;
         set(myplot,'Visible','on');
         drawnow;
         drawnow;
      else;
         file = [outputdir 'diff-' strtrim(namevector(j,:)) '-lagged-diffs-fitted-terms'];
         mstat = autosavefigure(myplot,file);
         stats = [stats mstat];
         file_names = strvcat(file_names,file);
      end;
   end;
end;

if r>0;
   n_cols = floor(sqrt(r));
   n_rows = ceil(r/n_cols);
   if n_cols*n_rows<r;
      n_rows = n_rows+1;
   end;
   %c_width = min(n_rows*350,realscrsz(3));
   c_width = min(n_cols*500,realscrsz(3));
   %c_height = min(n_rows*0.7*350,realscrsz(4));
   c_height = min((realscrsz(4)/realscrsz(3))*(c_width-100),realscrsz(4));

   %
   % cointegration relations
   %

   last_pos = get(gcf,'Position');
   thispos = last_pos(1:2)+[0 height-c_height];

   for j=1:n;
      coint_series = coint_vars(1+((j-1)*r):j*r,:);
      endo_series = Z_0_corr(j,:);
      thispos = [thispos(1,1)+22 thispos(1,2)-22];
      if thispos(1,1)>(realscrsz(3)-c_width);
         thispos = [0 realscrsz(4)-c_height];
      end;
      if thispos(1,2)>(realscrsz(4)-c_height);
         thispos = [0 realscrsz(4)-c_height];
      elseif thispos(1,2)<32;
         thispos = [0 realscrsz(4)-c_height];
      end;
      myplot = figure('Position',[thispos c_width c_height], ...
         'NumberTitle','off', ...
         'Visible','off', ...
         'Name',[strtrim(namevector(j,:)) ' and fitted lagged cointegration relations']);
      %
      % obey centering and filling defaults
      %
      setfigureproperties(myplot);
      %
      %
      % Setting up the sub plots
      %
      axeshandles = [];
      for i=1:r;
         subplot(n_rows,n_cols,i);
         plot(dataindex,endo_series','-','LineWidth',1,'Color',colorstr);
         hold('on');
         plot(dataindex,coint_series(i,:)',typestr,'LineWidth',1,'Color',colorstr2);
         hold('on');
         plot(dataindex,zeros(T,1),'-','LineWidth',1,'Color','k');
         set(gca,'XLim',[dataindex(1,1) dataindex(size(dataindex,1),1)]);
         setaxesfonts('Title',['\Delta' strtrim(namevector(j,:)) ' and fitted terms for cointegration relation ' num2str(i)]);
         myleg = legend_fcn(['\Delta ' strtrim(namevector(j,:))],['Coint. rel. no. ' num2str(i)],2);
         setaxesfonts(myleg);
         set(gca,'UserData',myleg);
         axeshandles = [axeshandles gca];
         hold('off');
      end;
      toolbar_fcn(axeshandles);
      %
      % take care of automatically saving the graphs
      %
      if curr_ini.external==0;
         set(myplot,'Visible','on');
         drawnow;
         drawnow;
      else;
         useres = '';
         file = [outputdir 'diff-' strtrim(namevector(j,:)) '-coint-relations-fitted-terms'];
         mstat = autosavefigure(myplot,file);
         stats = [stats mstat];
         file_names = strvcat(file_names,file);
      end;
   end;
end;

if curr_ini.external==1;
   if isempty(stats)==0;
      for i=1:size(stats,2);
         if stats(i)==0;
            autoshowfigure(strtrim(file_names(i,:)));
         end;
      end;
   end;
end;

%
% end of fitted_terms.m
%
