function [Gamma,stat] = gamma_rank_rnd(Z0,Z1,Z2,D,r,n,size_g,Omega,delta,alpha,beta,G_mu,G_sigma,cu_symmetric)

Z = Z0;
if isempty(delta)==0;
   Z = Z-(delta*D);
end;
if r>0;
   Z = Z-(alpha*beta'*Z1);
end;
%
% compute the mean and covariance for Gamma conditional on
% alpha, beta, delta, Omega, and the data
%
if isempty(G_sigma)==1;
   cov_mat = Z2*Z2';
else;
   cov_mat = (Z2*Z2')+inverse(G_sigma);
end;
cov_mat = inverse(cov_mat);
mean_vec = vec(Z*Z2'*cov_mat);
cov_mat = kron(cov_mat,Omega);

[std_mat,stat] = chol(cov_mat);
if stat>0;
   Gamma = [];
   return;
end;
%
if cu_symmetric==1;
   std_mat = symm(cov_mat);
end;

Gamma_vec = mean_vec+(std_mat'*randn(n*size_g,1));
Gamma = vecinv(Gamma_vec,n);

%
% end of gamma_rank_rnd.m
%
