function h = getfighandle(filename)


if isempty(find(filename == '.'))
  filename = [filename '.fig'];
end

fileVars = load(filename, '-mat');
varNames = fieldnames(fileVars);
index = 1;
for i=1:size(varNames,1);
   if strcmp(varNames{i},'hgS')==1;
      index = i;
      break;
   end;
end;

disp(varNames);
index = strmatch('hgS', varNames);
hgS = getfield(fileVars, varNames{index});

numHandles = prod(size(hgS));
parent = zeros(numHandles, 1);
for i = 1:numHandles
  switch(hgS(i).type)
    case 'root'
      parent = 0;
    case 'figure'
      parent(i) = 0;
    case {'axes' 'uimenu' 'uicontextmenu' 'uicontrol' 'uitoolbar'}
      parent(i) = gcf;
    case {'uipushtool' 'uitoggletool'}
%      parent(i) = gctb;
      parent(i) = 0;
    otherwise
      parent(i) = gca;
  end
end


h = struct2handle(hgS, parent, 'convert');


%
% end of getfighandle.m
%
