function [newfile,status,thesedates,sheetname,action_out] = loaddata(file,arg)

%
% creates an nxk matrix from file and report
% the status of data (1 is numeric, 0 is other)
%

if nargin==1;
   arg = '';
end;

dtstr = '';
status = 0;
stat_dim = 0;
if nargin==0;
   newfile = [];
   if nargout==3;
      thesedates = dtstr;
   end;
   return;
end;

sheetname = '';
action = '';
if nargout==5;
   action_out = '';
end;
newfile = [];

ext = getext(file);
if strcmp(ext,'.wk1')==0;
   if strcmp(ext,'.xls')==1;
      if matlabnumber>=6.0;
         if nargin==1;
            [newfile,thisname,dtstr,sheetname,action] = xlsread_fcn(file);
         else;
            [newfile,thisname,dtstr,sheetname,action] = xlsread_fcn(file,arg);
         end;
      end;
   elseif strcmp(ext,'.mat')==1;
         if nargin==1;
            [newfile,thisname,dtstr,sheetname,action] = matread_fcn(file);
         else;
            [newfile,thisname,dtstr,sheetname,action] = matread_fcn(file,arg);
         end;
   else;
      fid = fopen(file,'rt');
      if fid>-1;
         fileline = fgetl(fid);
         if ischar(fileline)==1;
            fileline = strtrim(fileline);
         end;
         newfile = '';
         while isnumeric(fileline)==0;
            if strcmp(fileline,'')==0;
               fileline = strrep(fileline,'"',' ');
               fileline = strrep(fileline,'''','');
%               fileline = strrep(fileline,'	','   ');
               fileline = swap_dates(fileline);
               fileline = strrep(fileline,'	','   ');
               fileline = strrep(fileline,'	,',' ');
               fileline = strrep(fileline,' ,',' ');
               if strcmp(lower(getext(file)),'.csv')==0;
                  fileline = strrep(fileline,',','.');
               else;
                  fileline = strrep(fileline,';',' ');
                  fileline = strrep(fileline,':',' ');
                  c_line = findstr(fileline,'.');
                  if isempty(c_line)==0;
                     fileline = strrep(fileline,',',' ');
                  else;
                     fileline = strrep(fileline,',','.');
                  end;
               end;
               fileline = strrep(fileline,',-',' -');
               fileline = strrep(fileline,', ',' ');
               %
               % fix fineline such that we know dates
               % are always specified with <colon> character
               %
               fileline = strrep(fileline,'#',':');
               fileline = strrep(fileline,'Q',':');
               fileline = strrep(fileline,'M',':');
               fileline = strrep(fileline,'Y',':1');
               fileline = strrep(fileline,'y',':1');
               fileline = strrep(fileline,'q',':');
               fileline = strrep(fileline,'m',':');
               fileline = strrep(fileline,'@',':');
               fileline = strrep(fileline,'(',':');
               fileline = strrep(fileline,')','');
               fileline = strrep(fileline,'[',':');
               fileline = strrep(fileline,']','');
               fileline = strrep(fileline,'{',':');
               fileline = strrep(fileline,'}','');
               fileline = strrep(fileline,';',':');
               fileline = strrep(fileline,'::',':');
               %
               % just in case a variable is named i
               %
               fileline = strrep(fileline,' i ',' @ ');
               if strcmp(newfile,'')==1;
                  if size(mystr2num(fileline),1)==1;
                     newfile = fileline;
                  end;
               else;
                  if size(mystr2num(fileline),1)==1;
                     newfile = strvcat(newfile,fileline);
                  end;
               end;
            end;
            fileline = fgetl(fid);
            if ischar(fileline)==1;
               fileline = strtrim(fileline);
            end;
         end;
         fclose(fid);
         if isempty(newfile)==0;
            [dtstr,newfile] = getdatestr(newfile);
         end;
         [newfile,stat_dim] = mystr2num(newfile);
      else;
         newfile = [];
      end;
   end;
else;
   [newfile,thisname,dtstr] = wk1read_fcn(file);
end;

if size(newfile,1)*size(newfile,2)>0;
   status = 1;
else;
   if stat_dim==-1;
      status = 0;
   else;
      status = -1;
   end;
end;

if nargout>=3;
   thesedates = dtstr;
end;

if nargout==5;
   action_out = action;
end;

%
% end of loaddata.m
%
