function move_light_fcn(in)

global moved_light lineentry

if nargin==0;
   in = 0;
end;

light_line = findobj(gca,'Type','line','UserData','light')';
if light_line==gco;
   h = get(0,'CurrentFigure');
   if in==0;
      if strcmp(get(h,'SelectionType'),'normal')==1;
         moved_light = 0;
         %
         % preparing the move of the light object
         %
         old_data.wbmf = get(h,'WindowButtonMotionFcn');
         old_data.wbuf = get(h,'WindowButtonUpFcn');
         set(h,'Pointer','fleur','DoubleBuffer','on');
         lineentry = uicontrol('Parent',h, ...
            'Units','pixels', ...
            'Position',[2 2 200 15], ...
            'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
            'Visible','off', ...
            'Style','text', ...
            'UserData',old_data, ...
            'FontSize',6, ...
            'ForegroundColor',[0.8 0 0], ...
            'HorizontalAlignment','left', ...
            'String','');
         set(h,'WindowButtonMotionFcn','move_light_fcn(1)','WindowButtonUpFcn','move_light_fcn(2)');
         light_line = findobj(gca,'Type','line','UserData','light')';
         set(light_line,'EraseMode','xor');
         ax_cp = get(gca,'CurrentPoint');
         ax_cp = ax_cp(1,:);
         set(lineentry,'Visible','on','String',['X: ' num2str(ax_cp(1),'%0.4f') '   Y: ' num2str(ax_cp(2),'%0.4f') '   Z: ' num2str(ax_cp(3),'%0.4f')]);
      end;
   elseif in==1;
      %
      % moving the light object
      %
      ax_cp = get(gca,'CurrentPoint');
      ax_cp = ax_cp(1,:);
      ax_xlim = get(gca,'XLim');
      ax_ylim = get(gca,'YLim');
      ax_zlim = get(gca,'ZLim');
      if (ax_cp(1)>=ax_xlim(1)-1)&(ax_cp(1)<=ax_xlim(2)+1)&(ax_cp(2)>=ax_ylim(1)-1)&(ax_cp(2)<=ax_ylim(2)+1)&(ax_cp(3)>=ax_zlim(1)-1)&(ax_cp(3)<=ax_zlim(2)+1);
         moved_light = 1;
         light_line = findobj(gca,'Type','line','UserData','light')';
         set(light_line,'XData',ax_cp(1),'YData',ax_cp(2),'ZData',ax_cp(3));
         my_light = findobj(gca,'Type','light')';
         set(my_light,'Position',ax_cp);
         set(lineentry,'Visible','on','String',['X: ' num2str(ax_cp(1),'%0.4f') '   Y: ' num2str(ax_cp(2),'%0.4f') '   Z: ' num2str(ax_cp(3),'%0.4f')]);
      else;
         set(lineentry,'Visible','off');
      end;
   elseif in==2;
      %
      % returning to normal
      %
      old_data = get(lineentry,'UserData');
      set(h,'Pointer','arrow','WindowButtonMotionFcn',old_data.wbmf,'WindowButtonUpFcn',old_data.wbuf,'DoubleBuffer','off');
      set(lineentry,'Visible','off','String','');
      delete(lineentry);
      light_line = findobj(gca,'Type','line','UserData','light')';
      set(light_line,'EraseMode','normal');
      if moved_light==1;
         %
         % fix context menu of axes
         %
         axes_context_menu = get(gca,'UIContextMenu');
         light_pos_parent = findobj(axes_context_menu,'Label','Light Position')';
         kids = sort(get(light_pos_parent,'Children')');
         for i=1:size(kids,2);
            set(kids(1,i),'Checked','off');
         end;
      end;
   end;
end;

%
% end of move_light_fcn.m
%
