function [status,myinfo] = mymkdir(basedir,newdir)

crdir = strcat(basedir,newdir);
testfile = strcat(basedir,'test.txt');

if isunix==1;
   status = unix(['mkdir ' crdir ' 2>' testfile]);
   if fileexist(testfile)==1;
      res = readtext(testfile);
      if size(res,2)==0;
         status = 2;
      else;
         status = 1;
      end
      nstatus = unix(['rm -f ' testfile]);
   end;
end;

switch status;
   case -2;
      ErrMsg = ['Cannot make directory ' newdir ' because a file in ' basedir ' already exists by that name.'];
   case -1;
      ErrMsg = ['Cannot make directory ' newdir ' because ' basedir ' does not exist.'];
   case 0;
      ErrMsg = ['Cannot make directory ' newdir '.'];
   case 1;
      ErrMsg = '';
   case 2;
      ErrMsg = ['Directory or file ' newdir ' already exists in ' basedir];
end;

if nargout==2;
   myinfo = ErrMsg;
end;

%
% end of mymkdir.m
%
