function parms = parameter_hist_fcn(parm_matrix)

%
% transforms frequencies of parameter values to a vector with parameter values with
% integers of how often they occur based on the frequencies and the length of the
% parm_matrix matrix
%

dx = parm_matrix(2,1)-parm_matrix(1,1);
param_mat = parm_matrix;
param_mat(:,2) = dx*param_mat(:,2);
param_mat(:,2) = cumsum(param_mat(:,2));
max_val = max(param_mat(:,2));

n = size(parm_matrix,1);
p_freq = round((n/max_val)*param_mat(:,2));
if max(p_freq)>n;
   p_freq = p_freq(p_freq<400);
   if size(p_freq,1)<n;
      p_freq = [p_freq;400*ones(n-size(p_freq,1),1)];
   end;
end;

p_freq(2:n,1) = p_freq(2:n,1)-p_freq(1:n-1,1);

parms = zeros(n,1);
val = 0;
for i=1:n;
   new_val = p_freq(i,1);
   if new_val>0;
      parms(val+1:val+new_val,1) = parm_matrix(i,1)*ones(new_val,1);
      val = val+new_val;
   end;
end;

%
% end of parameter_hist_fcn.m
%
