function print_corrtest(tm,curr_ini,epsilon,beta,beta_df,alpha_df,my_df)

fout = fopen(tm.outputfile,'at');
%
%[results1,degfreedom1] = autocorr(epsilon,tm.freq,tm.T-my_df);
[results1,degfreedom1] = lmautocorr(epsilon,tm.Z0,tm.Z1,tm.Z2,beta,tm.freq,tm.T-my_df);
%
if curr_ini.texoutputformat>=2;
   fprintf(fout,['\\subsection*{Serial correlation tests}\n\n\\header{For $r$=' num2str(tm.r) ', lags=' num2str(tm.p) ', \\#free $\\beta$ params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ', \\#free $\\alpha$ params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') '}\n\n']);
   fprintf(fout,'\\header{LM-type test statistic}\n\n');
   fprintf(fout,'\\begin{tabular}{ll}\n');
   fprintf(fout,'$H_0$: & residuals are serially uncorrelated \\\\\n');
   fprintf(fout,'$H_A$: & residuals follow VAR(1)\\\\[2mm]\n');
   if curr_ini.sscorrect==0;
      if strcmp(tm.freq,'')==1;
         fprintf(fout,[' & LM(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],degfreedom1,results1(1,1));
         fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results1(1,2));
      elseif strcmp(tm.freq,'q');
         fprintf(fout,[' & LM(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],strrep(degfreedom1(1,:),' ',''),results1(1,1));
         fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\[3mm]\n'],results1(1,2));
         fprintf(fout,'$H_0$: & residuals are serially uncorrelated \\\\\n');
         fprintf(fout,'$H_A$: & residuals follow VAR at lag 4 \\\\[2mm]\n');
         fprintf(fout,[' & LM(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],strrep(degfreedom1(2,:),' ',''),results1(1,3));
         fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results1(1,4));
      else;
         fprintf(fout,[' & LM(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],strrep(degfreedom1(1,:),' ',''),results1(1,1));
         fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\[3mm]\n'],results1(1,2));
         fprintf(fout,'$H_0$: & residuals are serially uncorrelated \\\\\n');
         fprintf(fout,'$H_A$: & residuals follow VAR at lag 12 \\\\[2mm]\n');
         fprintf(fout,[' & LM(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],strrep(degfreedom1(2,:),' ',''),results1(1,3));
         fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results1(1,4));
      end;
   else;
      if strcmp(tm.freq,'')==1;
         fprintf(fout,[' & F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],degfreedom1,results1(1,1));
         fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results1(1,2));
      elseif strcmp(tm.freq,'q');
         fprintf(fout,[' & F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],strrep(degfreedom1(1,:),' ',''),results1(1,1));
         fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\[3mm]\n'],results1(1,2));
         fprintf(fout,'$H_0$: & residuals are serially uncorrelated \\\\\n');
         fprintf(fout,'$H_A$: & residuals follow VAR at lag 4 \\\\[2mm]\n');
         fprintf(fout,[' & F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],strrep(degfreedom1(2,:),' ',''),results1(1,3));
         fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results1(1,4));
      else;
         fprintf(fout,[' & F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],strrep(degfreedom1(1,:),' ',''),results1(1,1));
         fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\[3mm]\n'],results1(1,2));
         fprintf(fout,'$H_0$: & residuals are serially uncorrelated \\\\\n');
         fprintf(fout,'$H_A$: & residuals follow VAR at lag 12 \\\\[2mm]\n');
         fprintf(fout,[' & F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],strrep(degfreedom1(2,:),' ',''),results1(1,3));
         fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results1(1,4));
      end;
   end;
   fprintf(fout,'\\end{tabular}\n\n\\ruler\n\n%%==============================================================================\n\n');
else;
   fprintf(fout,['SERIAL CORRELATION TESTS\n\n(for rank=' num2str(tm.r) ',lags=' num2str(tm.p) ',#free beta params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ',#free alpha params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') ') \n\n']);
   fprintf(fout,'  LM-type test statistic\n');
   fprintf(fout,'  ~~~~~~~~~~~~~~~~~~~~~~\n\n');
   fprintf(fout,'Null hypothesis:        residuals are serially uncorrelated\n');
   fprintf(fout,'Alternative hypothesis: residuals follow VAR(1)\n\n');
   if curr_ini.sscorrect==0;
      if strcmp(tm.freq,'')==1;
         fprintf(fout,['LM(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],degfreedom1,results1(1,1));
         fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],results1(1,2));
      elseif strcmp(tm.freq,'q');
         fprintf(fout,['LM(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],strrep(degfreedom1(1,:),' ',''),results1(1,1));
         fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],results1(1,2));
         fprintf(fout,'\nNull hypothesis:        residuals are serially uncorrelated\n');
         fprintf(fout,'Alternative hypothesis: residuals follow VAR at lag 4\n\n');
         fprintf(fout,['LM(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],strrep(degfreedom1(2,:),' ',''),results1(1,3));
         fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],results1(1,4));
      else;
         fprintf(fout,['LM(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],strrep(degfreedom1(1,:),' ',''),results1(1,1));
         fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],results1(1,2));
         fprintf(fout,'\nNull hypothesis:        residuals are serially uncorrelated\n');
         fprintf(fout,'Alternative hypothesis: residuals follow VAR at lag 12\n\n');
         fprintf(fout,['LM(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],strrep(degfreedom1(2,:),' ',''),results1(1,3));
         fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],results1(1,4));
      end;
   else;
      if strcmp(tm.freq,'')==1;
         fprintf(fout,['F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],degfreedom1,results1(1,1));
         fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],results1(1,2));
      elseif strcmp(tm.freq,'q');
         fprintf(fout,['F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],strrep(degfreedom1(1,:),' ',''),results1(1,1));
         fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],results1(1,2));
         fprintf(fout,'\nNull hypothesis:        residuals are serially uncorrelated\n');
         fprintf(fout,'Alternative hypothesis: residuals follow VAR at lag 4\n\n');
         fprintf(fout,['F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],strrep(degfreedom1(2,:),' ',''),results1(1,3));
         fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],results1(1,4));
      else;
         fprintf(fout,['F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],strrep(degfreedom1(1,:),' ',''),results1(1,1));
         fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],results1(1,2));
         fprintf(fout,'\nNull hypothesis:        residuals are serially uncorrelated\n');
         fprintf(fout,'Alternative hypothesis: residuals follow VAR at lag 12\n\n');
         fprintf(fout,['F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],strrep(degfreedom1(2,:),' ',''),results1(1,3));
         fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],results1(1,4));
      end;
   end;
   fprintf(fout,'\n===============================================================================\n\n');
end;
if curr_ini.portmanteau==1;
   [results2,degfreedom2] = portmanteau_fcn(epsilon,tm.p,tm);
   if curr_ini.texoutputformat>=2;
      fprintf(fout,'\\header{Ljung-Box-type test statistic}\n\n');
      fprintf(fout,'\\begin{tabular}{ll}\n');
      fprintf(fout,'$H_0$: & residuals are serially uncorrelated \\\\\n');
      fprintf(fout,'$H_A$: & %sth order residual correlation \\\\[2mm]\n',strrep(degfreedom2(2,:),' ',''));
      fprintf(fout,[' & LB(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],strrep(degfreedom2(1,:),' ',''),results2(1,1));
      fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results2(1,2));
      fprintf(fout,'\\end{tabular}\n\n\\ruler\n\n%%==============================================================================\n\n');
   else;
      fprintf(fout,'  Ljung-Box-type test statistic\n');
      fprintf(fout,'  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
      fprintf(fout,'Null hypothesis:        residuals are serially uncorrelated\n');
      fprintf(fout,'Alternative hypothesis: %sth order residual correlation\n\n',strrep(degfreedom2(2,:),' ',''));
      fprintf(fout,['LB(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],strrep(degfreedom2(1,:),' ',''),results2(1,1));
      fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],results2(1,2));
      fprintf(fout,'\n===============================================================================\n\n');
   end;
end;
fclose(fout);

%
% end of print_corrtest.m
%
