function delete_legend(ax)
%DELETE_LEGEND Remove legend from plot
if isempty(ax), return, end
ax = ax(1);
hf = get(ax,'parent');

% Remove auto-resize
resizefcn = get(hf,'resizefcn');
if strcmp(resizefcn,'legend_fcn(''ResizeLegend'')')
  set(hf,'resizefcn','')
end

ud = get(ax,'userdata');
if isfield(ud,'PlotHandle') & ishandle(ud.PlotHandle) & ...
   isfield(ud,'PlotPosition') & ~isempty(ud.PlotPosition) & ...
   ~DidAxesMove(ax)
  units = get(ud.PlotHandle,'units');
  set(ud.PlotHandle,'units','normalized','position',ud.PlotPosition)
  set(ud.PlotHandle,'units',units)
end
if isfield(ud,'DeleteProxy') & ishandle(ud.DeleteProxy)
  delete(ud.DeleteProxy)
end

%
% end of delete_legend.m
%
