function setaxesfonts(varargin)

%
% setaxesfonts('Title', str, 'XLabel', str, 'YLabel',str,'ZLabel',str)
% setaxesfonts(legendhandle)
%

curr_ini = find_inisettings;

%
% inserting text and fixing fonts and colors
%

if ischar(varargin{1})==1;
   %
   % taking care of the axes
   %
   set(gca,'FontSize',curr_ini.axes_fontsize, ...
           'FontName',curr_ini.axes_fontname, ...
           'FontWeight',curr_ini.axes_fontweight, ...
           'FontAngle',curr_ini.axes_fontangle, ...
           'FontUnits',curr_ini.axes_fontunits, ...
           'XColor',curr_ini.axes_color, ...
           'YColor',curr_ini.axes_color, ...
           'ZColor',curr_ini.axes_color);
   if curr_ini.xgrid==1;
      set(gca,'XGrid','on');
   else;
      set(gca,'XGrid','off');
   end;
   if curr_ini.ygrid==1;
      set(gca,'YGrid','on');
   else;
      set(gca,'YGrid','off');
   end;
   if curr_ini.zgrid==1;
      set(gca,'ZGrid','on');
   else;
      set(gca,'ZGrid','off');
   end;
   if curr_ini.box==1;
      set(gca,'Box','on');
   else;
      set(gca,'Box','off');
   end;
   num = round(size(varargin,2)/2);
   for i=1:num;
      k = 1+2*(i-1);
      if ischar(varargin{k})==1;
         if strcmp(lower(varargin{k}),'title')==1;
            tit_str = varargin{k+1};
            if isempty(findstr(tit_str,'_'))==0;
               tit_str = fix_ltxstr(tit_str,'_');
            end;
            title(tit_str);
            if (isempty(findstr(varargin{k+1},'_'))==0)|(isempty(findstr(varargin{k+1},'^'))==0);
               old_u = get(gca,'Units');
               set(gca,'Units','pixels');
               set(gca,'Position',get(gca,'Position')-[0 0 0 10]);
               set(gca,'Units',old_u);
            end;
         elseif strcmp(lower(varargin{k}),'xlabel')==1;
            xlabel(varargin{k+1});
         elseif strcmp(lower(varargin{k}),'ylabel')==1;
            ylabel(varargin{k+1});
         elseif strcmp(lower(varargin{k}),'zlabel')==1;
            zlabel(varargin{k+1});
         end;
      end;
   end;
   set(get(gca,'Title'),'FontSize',curr_ini.title_fontsize, ...
                        'FontName',curr_ini.title_fontname, ...
                        'FontWeight',curr_ini.title_fontweight, ...
                        'FontAngle',curr_ini.title_fontangle, ...
                        'FontUnits',curr_ini.title_fontunits, ...
                        'Color',curr_ini.title_color);
   set(get(gca,'XLabel'),'FontSize',curr_ini.label_fontsize, ...
                         'FontName',curr_ini.label_fontname, ...
                         'FontWeight',curr_ini.label_fontweight, ...
                         'FontAngle',curr_ini.label_fontangle, ...
                         'FontUnits',curr_ini.label_fontunits, ...
                         'Color',curr_ini.label_color);
   set(get(gca,'YLabel'),'FontSize',curr_ini.label_fontsize, ...
                         'FontName',curr_ini.label_fontname, ...
                         'FontWeight',curr_ini.label_fontweight, ...
                         'FontAngle',curr_ini.label_fontangle, ...
                         'FontUnits',curr_ini.label_fontunits, ...
                         'Color',curr_ini.label_color);
   set(get(gca,'Zlabel'),'FontSize',curr_ini.label_fontsize, ...
                         'FontName',curr_ini.label_fontname, ...
                         'FontWeight',curr_ini.label_fontweight, ...
                         'FontAngle',curr_ini.label_fontangle, ...
                         'FontUnits',curr_ini.label_fontunits, ...
                         'Color',curr_ini.label_color);
elseif ishandle(varargin{1})==1;
   thish = varargin{1};
   if strcmp(get(thish,'Tag'),'legend')==1;
      text_h = findobj(thish,'Type','text');
      for i0=1:size(text_h,1);
         set(text_h(i0,1),'FontName',curr_ini.axes_fontname);
         set(text_h(i0,1),'FontSize',curr_ini.axes_fontsize);
         set(text_h(i0,1),'FontWeight',curr_ini.axes_fontweight);
         set(text_h(i0,1),'FontAngle',curr_ini.axes_fontangle);
         set(text_h(i0,1),'FontUnits',curr_ini.axes_fontunits);
         set(text_h(i0,1),'Color',curr_ini.axes_color);
      end;
   elseif strcmp(get(thish,'Tag'),'colorbar')==1;
      set(thish,'FontSize',curr_ini.axes_fontsize, ...
              'FontName',curr_ini.axes_fontname, ...
              'FontWeight',curr_ini.axes_fontweight, ...
              'FontAngle',curr_ini.axes_fontangle, ...
              'FontUnits',curr_ini.axes_fontunits, ...
              'XColor',curr_ini.axes_color, ...
              'YColor',curr_ini.axes_color);
   end;
end;

%
% end of setaxesfonts.m
%
