function show_exclusion(fig_handle,tm,curr_ini)

set(fig_handle,'Visible','off');
drawnow;
%
% compute the tests
%
[tests,deg_free,pvals] = coint_exclusion(tm.S_00,tm.S_01,tm.S_10,tm.S_11,tm.M_02,tm.M_22,tm.M_12,tm.Z0,tm.Z1,tm.Z2,tm.epsilon,tm.r,tm.q1,tm.dcoint,tm.df,curr_ini.sscorrect);
%
% create the output text string
%
txt = strvcat(' ',['TESTING EXCLUSION RESTRICTIONS (for rank=' num2str(tm.r) ')']);
numchar = size(txt,2);
addtxt = '';
for i=1:numchar;
   addtxt = strcat(addtxt,'=');
end;
txt = strvcat(txt,addtxt,' ');
txt = strvcat(txt,'  LR-type test statistic','  ~~~~~~~~~~~~~~~~~~~~~~');
%
myvars = tm.myvars;
if tm.q1>0;
   myvars = strvcat(myvars,vecstr(tm.xvars1));
end;
if tm.dcoint>0;
   myvars = strvcat(myvars,vecstr(tm.restvec));
end;
%
add_space = '';
if size(myvars,2)>2;
   for i=1:size(myvars,2)-2;
      add_space = [add_space ' '];
   end;
end;
sp_str = spacestr(curr_ini.decimals-2);
%
txt = strvcat(txt,' ','Null Hypothesis:        row k (variable k) of beta is zero');
txt = strvcat(txt,'Alternative Hypothesis: row k (variable k) of beta is not zero',' ');
if curr_ini.sscorrect==0;
   txt = strvcat(txt,[' k' add_space '      LR   ' sp_str '   df      p-value'],' ');
   for i=1:size(tests,1);
      out = sprintf(['%s   %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f     %2.0f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],myvars(i,:),tests(i,1),deg_free(i,1),pvals(i,1));
      txt = strvcat(txt,out);
   end;
else;
   txt = strvcat(txt,[' k' add_space '      F     ' sp_str '     df         p-value'],' ');
   for i=1:size(tests,1);
      out = sprintf(['%s   %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f     (%2.0f,%3.0f)      %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],myvars(i,:),tests(i,1),deg_free(i,1),deg_free(i,2),pvals(i,1));
      txt = strvcat(txt,out);
   end;
end;
txt = strvcat(txt,' ');
%
% display the results
%
realscrsz = get(0,'ScreenSize');
textgui(txt,'Exclusion Restrictions on Beta',[(realscrsz(3)-680)/2 (realscrsz(4)-400)/2 680 400],'Results',38);
%
set(fig_handle,'Visible','on');
drawnow;

%
% end of show_exclusion.m
%
