function show_firstdiffstests(fig_handle,beta,alpha,Psi,Sigma_theta,tm,curr_ini,ind,c_ind)

set(fig_handle,'Visible','off');
drawnow;

res_str = '';
if ind==1;
   res_str = ' restricted';
end;
realscrsz = get(0,'ScreenSize');
%
evars = tm.myvars;
if strcmp(tm.xvars1,'')==0;
   xvars1 = vecstr(tm.xvars1);
else;
   xvars1 = '';
end;
if strcmp(tm.xvars0,'')==0;
   xvars0 = vecstr(tm.xvars0);
else;
   xvars0 = '';
end;
allvars = strvcat(evars,xvars1,xvars0);
evars = allvars(1:tm.n,:);
if tm.q1>0;
   xvars1 = allvars(tm.n+1:tm.n+tm.q1,:);
end;
if tm.q0>0;
   xvars0 = allvars(tm.n+tm.q1+1:tm.n+tm.q1+tm.q0,:);
end;
add_str = spacestr(size(allvars,2));
sp_str = spacestr(curr_ini.decimals-2);
%
% compute the tests
%
[results,dfmat,pvals] = exclude_firstdiffs(Psi,alpha,beta,tm.p,tm.pe,tm.epsilon,tm.Z1,tm.Z2,tm.q1,tm.q0,tm.d,tm.T-tm.df,Sigma_theta,curr_ini.sscorrect,tm.modelsdir,tm.modelfile,c_ind);
%
% display the results
%
txt_str = strvcat(' ',['EXCLUSION TESTS FOR FIRST DIFFERENCES (for' res_str ' rank=' num2str(tm.r,'%1.0f') ')']);
numchar = size(txt_str,2);
addcorr = '';
for i=1:numchar;
   addcorr = strcat(addcorr,'=');
end;
txt_str = strvcat(txt_str,addcorr,' ');
txt_str = strvcat(txt_str,'  Wald-type test statistic','  ~~~~~~~~~~~~~~~~~~~~~~~~',' ');
num = 1;
for i=1:tm.n;
   txt_str = strvcat(txt_str,['Null Hypothesis:        variables can be excluded from the ' strtrim(tm.myvars(i,:)) ' equation']);
   txt_str = strvcat(txt_str,['Alternative Hypothesis: variables cannot be excluded from the ' strtrim(tm.myvars(i,:)) ' equation'],' ');
   if curr_ini.sscorrect==0;
      txt_str = strvcat(txt_str,['Variables         ' add_str 'W  ' sp_str '   df     p-value']);
   else;
      txt_str = strvcat(txt_str,['Variables         ' add_str 'F  ' sp_str '      df        p-value']);
   end;
   if (tm.p>1)&(tm.n>2);
      for j=1:tm.n;
         if j~=i;
            if results.individual(num,1)>0;
               if curr_ini.sscorrect==0;
                  out = sprintf(['Diffs of %s:    %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    %2.0f     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],evars(j,:),results.individual(num,1),dfmat.individual(num,1),pvals.individual(num,1));
               else;
                  out = sprintf(['Diffs of %s:    %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    (%2.0f,%3.0f)     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],evars(j,:),results.individual(num,1),dfmat.individual(num,1),dfmat.individual(num,2),pvals.individual(num,1));
               end;
               txt_str = strvcat(txt_str,out);
            else;
               txt_str = strvcat(txt_str,['Diffs of ' evars(j,:) ':    Not computed']);
            end;
            num = num+1;
         end;
      end;
      %
      % all endogenous
      %
      if results.endo(i,1)>0;
         if curr_ini.sscorrect==0;
            out = sprintf(['All above:    ' add_str '%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    %2.0f     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],results.endo(i,1),dfmat.endo(i,1),pvals.endo(i,1));
         else;
            out = sprintf(['All above:    ' add_str '%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    (%2.0f,%3.0f)     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],results.endo(i,1),dfmat.endo(i,1),dfmat.endo(i,2),pvals.endo(i,1));
         end;
         txt_str = strvcat(txt_str,out);
      else;
         txt_str = strvcat(txt_str,['All above:    ' add_str 'Not computed']);
      end;
   end;
   %
   % check for exogenous I(1)
   %
   if (tm.q1>0)&(tm.pe>0);
      for j=1:tm.q1;
         if results.individual(num,1)>0;
            if curr_ini.sscorrect==0;
               out = sprintf(['Diffs of %s:    %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    %2.0f     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],xvars1(j,:),results.individual(num,1),dfmat.individual(num,1),pvals.individual(num,1));
            else;
               out = sprintf(['Diffs of %s:    %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    (%2.0f,%3.0f)     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],xvars1(j,:),results.individual(num,1),dfmat.individual(num,1),dfmat.individual(num,2),pvals.individual(num,1));
            end;
            txt_str = strvcat(txt_str,out);
         else;
            txt_str = strvcat(txt_str,['Diffs of ' xvars1(j,:) ':    Not computed']);
         end;
         num = num+1;
      end;
   end;
   %
   % check for exogenous I(0)
   %
   if tm.q0>0;
      for j=1:tm.q0;
         if results.individual(num,1)>0;
            if curr_ini.sscorrect==0;
               out = sprintf(['         %s:    %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    %2.0f     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],xvars0(j,:),results.individual(num,1),dfmat.individual(num,1),pvals.individual(num,1));
            else;
               out = sprintf(['         %s:    %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    (%2.0f,%3.0f)     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],xvars0(j,:),results.individual(num,1),dfmat.individual(num,1),dfmat.individual(num,2),pvals.individual(num,1));
            end;
            txt_str = strvcat(txt_str,out);
         else;
            txt_str = strvcat(txt_str,['         ' xvars0(j,:) ':    Not computed']);
         end;
         num = num+1;
      end;
   end;
   if (isfield(results,'exo')==1)&(tm.q1+tm.q0>1);
      if results.exo(i,1)>0;
         if curr_ini.sscorrect==0;
            out = sprintf(['All exogenous:' add_str '%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    %2.0f     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],results.exo(i,1),dfmat.exo(i,1),pvals.exo(i,1));
         else;
            out = sprintf(['All exogenous:' add_str '%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    (%2.0f,%3.0f)     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],results.exo(i,1),dfmat.exo(i,1),dfmat.exo(i,2),pvals.exo(i,1));
         end;
         txt_str = strvcat(txt_str,out);
      else;
         txt_str = strvcat(txt_str,['All exogenous:' add_str 'Not computed']);
      end;
   end;
   %
   % If there's a test for all variables
   %
   if isfield(results,'full')==1;
      if results.full(i,1)>0;
         if curr_ini.sscorrect==0;
            out = sprintf(['All:          ' add_str '%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    %2.0f     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],results.full(i,1),dfmat.full(i,1),pvals.full(i,1));
         else;
            out = sprintf(['All:          ' add_str '%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    (%2.0f,%3.0f)     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],results.full(i,1),dfmat.full(i,1),dfmat.full(i,2),pvals.full(i,1));
         end;
         txt_str = strvcat(txt_str,out);
      else;
         txt_str = strvcat(txt_str,['All:          ' add_str 'Not computed']);
      end;
   end;
   txt_str = strvcat(txt_str,' ');
end;
%
textgui(txt_str,'Exclusion Tests - First Differences',[(realscrsz(3)-680)/2 (realscrsz(4)-400)/2 680 400],'Results',38);
set(fig_handle,'Visible','on');
drawnow;

%
% end of show_firstdiffstests.m
%
