function show_recursive_trace(fig_handle,tm,curr_ini)

set(fig_handle,'Visible','off');
drawnow;
drawnow;
realscrsz = get(0,'ScreenSize');
[traceT,bart_corr,abort] = rec_trace(tm.Z0,tm.Z1,tm.Z2,tm.d,tm.p,tm.q1,tm.q0,tm.cointvalue,tm.dd,tm.ds,curr_ini.T0,tm.deterselect,1);
plot_handles = [];

if (isempty(traceT)==0)|(strcmp(abort,'cancel')==1);
   set(fig_handle,'Visible','on');
   drawnow;
   drawnow;
   if strcmp(abort,'cancel')==0;
      T1 = tm.T-size(traceT,2)+1;
      if curr_ini.colors==1;
         colorstr = 'b';
         colorstr2 = 'r';
         typestr = '-';
      else;
         colorstr = 'k';
         colorstr2 = [0.5 0.5 0.5];
         typestr = '--';
      end;
      %
      % check if we should select p-values
      %
      if ((tm.n<=12)&(tm.q0==0)&(tm.q1<=11)&(tm.dummies==0))|((tm.dummies==0)&(tm.q1==0)&(tm.q0>0));
         rec_pvals = zeros(size(traceT));
      else;
         rec_pvals = [];
      end;
      %
      % setting up the actual sample period
      %
      dataindex = make_dataindex(tm.freq,tm.samplebeg,tm.sampleend);
      thispos = [(realscrsz(3)-612)/2-22 (realscrsz(4)-484)/2+22];
      stats = [];
      file_names = '';
      %
      % Display the trace tests
      %
      if curr_ini.rectrace==1;
         if tm.critvalnum>5;
            tm.critvalnum = 3;
         end;
         if (tm.dummies==0)&((tm.q1+tm.q0)==0)&(tm.n<=12);
            mydist = trace_quant(tm.n,tm.deterselect,tm.cbs);
            if isempty(rec_pvals)==0;
               for i=1:size(rec_pvals,2);
                  rec_pvals(:,i) = tracepval(tm.n,traceT(:,i),tm.deterselect);
               end;
            end;
         elseif (tm.dummies==0)&(tm.q1>0)&(tm.q1<12)&(tm.q0==0)&(tm.n<=12)&((tm.deterselect(1,2)==1)|(tm.deterselect(1,4)==1));
            mydist = trace_quant_exo(tm.n,tm.q1,tm.deterselect,tm.cbs);
            if isempty(rec_pvals)==0;
               for i=1:size(rec_pvals,2);
                  rec_pvals(:,i) = tracepval_exo(tm.n,tm.q1,traceT(:,i),tm.deterselect);
               end;
            end;
         elseif (tm.dummies==0)&(tm.q1==0)&(tm.q0>0);
            mydist = trace_exoi0_dist(tm.n,tm.p,tm.pe,tm.q0,tm.cbs,tm.deterselect,tm.d,tm.beta,tm.S_01,tm.M_02,tm.M_12,tm.M_22,tm.Z0,tm.Z1,tm.Z2);
            mydist = reverse(mydist);
            if isempty(rec_pvals)==0;
               for i=1:size(rec_pvals,2);
                  rec_pvals(:,i) = tracepval_exoi0(tm.n,tm.p,tm.pe,tm.q0,traceT(:,i),tm.deterselect,tm.d,tm.beta,tm.S_01,tm.M_02,tm.M_12,tm.M_22,tm.Z0,tm.Z1,tm.Z2);
               end;
            end;
         else;
            mydist = [];
         end;
         %
         if strcmp(bart_corr,'on')==1;
            bart_str = 'Bartlett corrected';
         else;
            bart_str = 'Uncorrected';
         end;
         %
         for i=1:tm.n;
            thispos = [thispos(1,1)+22 thispos(1,2)-22];
            if thispos(1,1)>(realscrsz(3)-612);
               thispos = [0 realscrsz(4)-564];
            end;
            if thispos(1,2)>(realscrsz(4)-564);
               thispos = [0 realscrsz(4)-564];
            elseif thispos(1,2)<32;
               thispos = [0 realscrsz(4)-564];
            end;
            if i==1;
               name_str = '(r=0)';
               name_str2 = '(r=0)';
            else;
               name_str = ['(r=' num2str(i-1,'%0.0f') ')'];
               name_str2 = ['(r\leq' num2str(i-1,'%0.0f') ')'];
            end;
            myplot = figure('Units','pixels', ...
               'Position',[thispos 612 484], ...
               'NumberTitle','off', ...
               'Menubar','none', ...
               'Toolbar','none', ...
               'Visible','off', ...
               'Name',['Recursive Trace Tests ' name_str]);
            %
            % obey centering and filling defaults
            %
            setfigureproperties(myplot);
            %
            if isempty(rec_pvals)==0;
               subplot(2,1,1);
            end;
            %
            % Setting up the plot
            %
            plot(dataindex(T1:tm.T,1),traceT(i,:)','-','LineWidth',1,'Color',colorstr,'Tag',['rec-trace' name_str]);
            %
            % add critical value when available
            %
            if isempty(mydist)==0;
               hold('on');
               plot([dataindex(T1,1) dataindex(tm.T,1)],mydist(tm.n-i+1,1)*ones(1,2),typestr,'LineWidth',1,'Color',colorstr2);
            end;
            %
            set(gca,'XLim',[dataindex(T1,1) dataindex(tm.T,1)]);
            %
            % Fix YLim
            %
            if isempty(mydist)==0;
               set(gca,'YLim',[0 max(max(traceT(i,:)),mydist(tm.n-i+1,1))+0.5]);
               setaxesfonts('Title',[bart_str ' recursive trace tests with ' num2str(tm.cbs) ' % critical value']);
               myleg = legend_fcn(['Trace test ' name_str2],['cr. val. (' num2str(mydist(tm.n-i+1,1),'%0.2f') ')'],2);
               setaxesfonts(myleg);
               set(gca,'UserData',myleg);
            else;
               set(gca,'YLim',[0 max(traceT(i,:))+0.5]);
               setaxesfonts('Title',[bart_str ' recursive trace tests']);
            end;
            axeshandles = gca;
            if isempty(rec_pvals)==0;
               hold('off');
               subplot(2,1,2);
               plot(dataindex(T1:tm.T,1),rec_pvals(i,:)','-','LineWidth',1,'Color',colorstr,'Tag',['rec-pvals' name_str]);
               %
               % the default test-level
               %
               hold('on');
               plot([dataindex(T1,1) dataindex(tm.T,1)],(1-(tm.cbs/100))*ones(1,2),typestr,'LineWidth',1,'Color',colorstr2);
               set(gca,'YLim',[0 1],'XLim',[dataindex(T1,1) dataindex(tm.T,1)]);
               setaxesfonts('Title','Recursive p-values');
               myleg = legend_fcn(['p-values ' name_str2],'Nominal size',2);
               setaxesfonts(myleg);
               axeshandles = [axeshandles gca];
            end;
            %
            toolbar_fcn(axeshandles);
            hold('off');
            if curr_ini.external==0;
               plot_handles = [plot_handles myplot];
            else;
               file = [tm.outputdir 'trace-unrest-' num2str(tm.n) 'x' num2str(tm.r) '.' num2str(i)];
               mstat = autosavefigure(myplot,file);
               stats = [stats mstat];
               file_names = strvcat(file_names,file);
            end;
         end;
      end;
      %
      if (curr_ini.external==1)&(isempty(stats)==0);
         for i=1:size(stats,2);
            if stats(i)==0;
               autoshowfigure(strtrim(file_names(i,:)));
            end;
         end;
      elseif curr_ini.external==0;
         for i=1:size(plot_handles,2);
            set(plot_handles(1,i),'Visible','on');
            drawnow;
         end;
      end;
   end;
else;
   txt = 'There are too few observations to estimate parameters recursively.';
   about(txt,'information','Recursions...',120,350);
   set(fig_handle,'Visible','on');
   drawnow;
end;

%
% end of show_recursive_trace.m
%
