function show_recursiveeig(fig_handle,tm,curr_ini)

set(fig_handle,'Visible','off');
drawnow;
drawnow;
realscrsz = get(0,'ScreenSize');
%
if curr_ini.fullrec==1;
   [lambdaT,lambdastd,sigmastd,tauT,nyblomT,nyblomcorr,xisumT,xistdT,evaluet,tT,abort] = reclambda(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.d,curr_ini.T0,tm.df,tm.deterselect,1);
else;
   [lambdaT,lambdastd,sigmastd,tauT,nyblomT,nyblomcorr,xisumT,xistdT,evaluet,tT,abort] = rectlambda(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.d,curr_ini.T0,tm.df,tm.deterselect,1);
end;
plot_handles = [];
if isempty(lambdaT)==0;
   set(fig_handle,'Visible','on');
   drawnow;
   drawnow;
   if strcmp(abort,'cancel')==0;
      lambdastd = sqrt(lambdastd);
      sigmastd = sqrt(sigmastd);
      T1 = tm.T-size(lambdaT,2)+1;
      if curr_ini.colors==1;
         colorstr = 'b';
         colorstr2 = 'r';
         typestr = '-';
      else;
         colorstr = 'k';
         colorstr2 = [0.5 0.5 0.5];
         typestr = '--';
      end;
      %
      % setting up the actual sample period
      %
      dataindex = make_dataindex(tm.freq,tm.samplebeg,tm.sampleend);
      cbvalue = cbsval(tm.cbs);
      plobvalue = plobval(tm.cbs);
      upper_c = -cbvalue*real(sigmastd);
      lower_c = cbvalue*real(sigmastd);
      if curr_ini.transeig==1;
         lambdaT = log( (lambdaT ./ (ones(size(lambdaT))-lambdaT)) );
         upper_c = lambdaT+upper_c;
         lower_c = lambdaT+lower_c;
      else;
         upper_c = exp(upper_c);
         lower_c = exp(lower_c);
         upper_c = lambdaT+((1-lambdaT).*upper_c);
         lower_c = lambdaT+((1-lambdaT).*lower_c);
         upper_c = lambdaT./upper_c;
         lower_c = lambdaT./lower_c;
         upper_c = real(upper_c);
         lower_c = real(lower_c);
      end;
      thispos = [(realscrsz(3)-550)/2-22 (realscrsz(4)-360)/2+22];
      stats = [];
      file_names = '';
      for i=1:tm.r;
         thispos = [thispos(1,1)+22 thispos(1,2)-22];
         if thispos(1,1)>(realscrsz(3)-550);
            thispos = [0 realscrsz(4)-430];
         end;
         if thispos(1,2)>(realscrsz(4)-430);
            thispos = [0 realscrsz(4)-430];
         elseif thispos(1,2)<32;
            thispos = [0 realscrsz(4)-430];
         end;
         myplot = figure('Units','pixels', ...
            'Position',[thispos 550 360], ...
            'Menubar','none', ...
            'Toolbar','none', ...
            'NumberTitle','off', ...
            'Visible','off', ...
            'Name',['Recursive Eigenvalue Number ' num2str(i)]);
         %
         % obey centering and filling defaults
         %
         setfigureproperties(myplot);
         %
         %
         % changing the name if needed
         %
         if curr_ini.transeig==1;
            set(myplot,'Name',['Recursive Transformed Eigenvalue Number ' num2str(i)]);
         end;
         %
         % Using a patch to display the confidence region
         %
         if curr_ini.colors==1;
            colorstr3 = (1/255)*[255 255 177];
         else;
            colorstr3 = [0.6 0.6 0.6];
         end;
         my_p = patch([dataindex(T1:tm.T,1)' reverse(dataindex(T1:tm.T,1)')],[upper_c(i,:) reverse(lower_c(i,:))],colorstr3);
         set(my_p,'FaceColor',colorstr3,'EdgeColor',colorstr3,'Tag','confpatch','LineWidth',1);
         hold('on');
         %
         % Setting up the plot
         %
         plot(dataindex(T1:tm.T,1),lambdaT(i,:)','-','LineWidth',1,'Color',colorstr,'Tag',['lambda-' num2str(i)]);
         hold('on');
%         plot(dataindex(T1:tm.T,1),upper_c(i,:)',typestr,'LineWidth',1,'Color',colorstr2);
%         hold('on');
%         plot(dataindex(T1:tm.T,1),lower_c(i,:)',typestr,'LineWidth',1,'Color',colorstr2);
         set(gca,'XLim',[dataindex(T1,1) dataindex(tm.T,1)],'Layer','top');
         if curr_ini.transeig==0;
            set(gca,'YLim',[0 1]);
         end;
         if curr_ini.fullrec==0;
            if (tm.deterselect(1,1)==1)|(tm.deterselect(1,3)==1);
               textadd = ' (for updated \delta_{i},\Gamma_{i})';
            else;
               textadd = ' (for updated \Gamma_{i})';
            end;
         else;
            if (tm.deterselect(1,1)==1)|(tm.deterselect(1,3)==1);
               textadd = ' (for fixed \delta_{i},\Gamma_{i})';
            else;
               textadd = ' (for fixed \Gamma_{i})';
            end;
         end;
         if curr_ini.transeig==1;
            my_title = ['Estimated log[\lambda_{' num2str(i) '}/(1-\lambda_{' num2str(i) '})] with ' num2str(tm.cbs) ' % confidence bands' textadd];
         else;
            my_title = ['Estimated \lambda_{' num2str(i) '} with ' num2str(tm.cbs) ' % confidence bands' textadd];
         end;
         setaxesfonts('Title',my_title);
%         old_ax_units = get(gca,'Units');
%         set(gca,'Units','pixels');
%         ax_pos = get(gca,'Position');
%         set(gca,'Position',ax_pos-[0 0 0 10]);
%         set(gca,'Units',old_ax_units);
         toolbar_fcn(gca);
         hold('off');
         if curr_ini.external==0;
            plot_handles = [plot_handles myplot];
         else;
            file = [tm.outputdir 'lambda-' num2str(i)];
            mstat = autosavefigure(myplot,file);
            stats = [stats mstat];
            file_names = strvcat(file_names,file);
         end;
      end;
      if min(xistdT)>0;
         t1 = size(xisumT,2);
         tauxisumT = xisumT-(xisumT(1,t1)*ones(1,t1));
         tauxisumT = abs(tT.*(tauxisumT./(sqrt(xistdT(1,t1))*ones(1,t1))));
         xistdT = sqrt(xistdT);
         thispos =[thispos(1,1)+22 thispos(1,2)-22];
         if thispos(1,1)>(realscrsz(3)-550);
            thispos = [0 realscrsz(4)-430];
         end;
         if thispos(1,2)>(realscrsz(4)-430);
            thispos = [0 realscrsz(4)-430];
         elseif thispos(1,2)<32;
            thispos = [0 realscrsz(4)-430];
         end;
         myplot = figure('Units','pixels', ...
            'Position',[thispos 550 360], ...
            'Menubar','none', ...
            'Toolbar','none', ...
            'NumberTitle','off', ...
            'Visible','off', ...
            'Name','Sum of log(eig/[1-eig])');
         %
         % obey centering and filling defaults
         %
         setfigureproperties(myplot);
         %
         %
         % Using a patch to display the confidence region
         %
         if curr_ini.colors==1;
            colorstr3 = (1/255)*[255 255 177];
         else;
            colorstr3 = [0.6 0.6 0.6];
         end;
         my_p = patch([dataindex(T1:tm.T,1)' reverse(dataindex(T1:tm.T,1)')],[(xisumT+(cbvalue*xistdT)) reverse((xisumT-(cbvalue*xistdT)))],colorstr3);
         set(my_p,'FaceColor',colorstr3,'EdgeColor',colorstr3,'Tag','confpatch','LineWidth',1);
         hold('on');
         %
         % Setting up the plot
         %
         plot(dataindex(T1:tm.T,1),xisumT','-','LineWidth',1,'Color',colorstr,'Tag','sum-lambda');
         hold('on');
%         plot(dataindex(T1:tm.T,1),(xisumT+(cbvalue*xistdT))',typestr,'LineWidth',1,'Color',colorstr2);
%         hold('on');
%         plot(dataindex(T1:tm.T,1),(xisumT-(cbvalue*xistdT))',typestr,'LineWidth',1,'Color',colorstr2);
         set(gca,'XLim',[dataindex(T1,1) dataindex(tm.T,1)],'Layer','top');
         set(gca,'YLim',[min(xisumT-(cbvalue*xistdT)) max(xisumT+(cbvalue*xistdT))]);
         setaxesfonts('Title',['Estimated \Sigma_{i=1}^{' num2str(tm.r) '}log[\lambda_{i}/(1-\lambda_{i})] with ' num2str(tm.cbs) ' % confidence bands' textadd]);
%         old_ax_units = get(gca,'Units');
%         set(gca,'Units','pixels');
%         ax_pos = get(gca,'Position');
%         set(gca,'Position',ax_pos-[0 0 0 10]);
%         set(gca,'Units',old_ax_units);
         toolbar_fcn(gca);
         hold('off');
         if curr_ini.external==0;
            plot_handles = [plot_handles myplot];
         else;
            file = [tm.outputdir 'xi-' num2str(tm.r)];
            mstat = autosavefigure(myplot,file);
            stats = [stats mstat];
            file_names = strvcat(file_names,file);
         end;
      end;
      if curr_ini.fluctest==1;
         for i=1:tm.r;
            thispos =[thispos(1,1)+22 thispos(1,2)-22];
            if thispos(1,1)>(realscrsz(3)-550);
               thispos = [0 realscrsz(4)-430];
            end;
            if thispos(1,2)>(realscrsz(4)-430);
               thispos = [0 realscrsz(4)-430];
            elseif thispos(1,2)<32;
               thispos = [0 realscrsz(4)-430];
            end;
            myplot = figure('Units','pixels', ...
               'Position',[thispos 550 360], ...
               'Menubar','none', ...
               'Toolbar','none', ...
               'NumberTitle','off', ...
               'Visible','off', ...
               'Name',['Fluctuation Test for Eigenvalue Number ' num2str(i)]);
            %
            % obey centering and filling defaults
            %
            setfigureproperties(myplot);
            %
            %
            % Fix name if needed
            %
            if curr_ini.transeig==1;
               set(myplot,'Name',['Fluctuation Test for Transformed Eigenvalue Number ' num2str(i)]);
            end;
            %
            % Setting up the plot
            %
            plot(dataindex(T1:tm.T,1),tauT(i,:)','-','LineWidth',1,'Color',colorstr,'Tag',['tau-lambda-' num2str(i)]);
            hold('on');
            plot(dataindex(T1:tm.T,1),plobvalue*ones(size(tauT,2),1),typestr,'LineWidth',1,'Color',colorstr2);
            set(gca,'XLim',[dataindex(T1,1) dataindex(tm.T,1)]);
            set(gca,'YLim',[0 max([plobvalue+0.2 max(max(tauT))+0.5])]);
            if curr_ini.transeig==1;
               my_title = ['Estimated \tau_{T}^{(t)}(log[\lambda_{' num2str(i) '}/(1-\lambda_{' num2str(i) '})]) with ' num2str(tm.cbs) ' % critical value ' num2str(plobvalue) textadd];
            else;
               my_title = ['Estimated \tau_{T}^{(t)}(\lambda_{' num2str(i) '}) with ' num2str(tm.cbs) ' % critical value' textadd];
            end;
            setaxesfonts('Title',my_title);
%            old_ax_units = get(gca,'Units');
%            set(gca,'Units','pixels');
%            ax_pos = get(gca,'Position');
%            set(gca,'Position',ax_pos-[0 0 0 10]);
%            set(gca,'Units',old_ax_units);
            %
            % setting up a legend
            %
            myleg = legend_fcn('Fluctuation tests',['cr. val. (' num2str(plobvalue,'%0.3f') ')'],1);
            setaxesfonts(myleg);
            set(gca,'UserData',myleg);
            toolbar_fcn(gca);
            hold('off');
            if curr_ini.external==0;
               plot_handles = [plot_handles myplot];
            else;
               file = [tm.outputdir 'tau-' num2str(i)];
               mstat = autosavefigure(myplot,file);
               stats = [stats mstat];
               file_names = strvcat(file_names,file);
            end;
         end;
         if min(xistdT)>0;
            thispos =[thispos(1,1)+22 thispos(1,2)-22];
            if thispos(1,1)>(realscrsz(3)-550);
               thispos = [0 realscrsz(4)-430];
            end;
            if thispos(1,2)>(realscrsz(4)-430);
               thispos = [0 realscrsz(4)-430];
            elseif thispos(1,2)<32;
               thispos = [0 realscrsz(4)-430];
            end;
            myplot = figure('Units','pixels', ...
               'Position',[thispos 550 360], ...
               'NumberTitle','off', ...
               'Menubar','none', ...
               'Toolbar','none', ...
               'Visible','off', ...
               'Name','Fluctuation Tests for Sum of log(eig/[1-eig])');
            %
            % obey centering and filling defaults
            %
            setfigureproperties(myplot);
            %
            %
            % Setting up the plot
            %
            plot(dataindex(T1:tm.T,1),tauxisumT','-','LineWidth',1,'Color',colorstr,'Tag','tau-sum-lambda');
            hold('on');
            plot(dataindex(T1:tm.T,1),plobvalue*ones(size(tauxisumT,2),1),typestr,'LineWidth',1,'Color',colorstr2);
            set(gca,'XLim',[dataindex(T1,1) dataindex(tm.T,1)]);
            set(gca,'YLim',[0 max([plobvalue+0.2 max(tauxisumT)+0.5])]);
            setaxesfonts('Title',['Estimated \tau_{T}^{(t)}(\Sigma_{i=1}^{' num2str(tm.r) '}log[\lambda_{i}/(1-\lambda_{i})]) with ' num2str(tm.cbs) ' % critical value' textadd]);
%            old_ax_units = get(gca,'Units');
%            set(gca,'Units','pixels');
%            ax_pos = get(gca,'Position');
%            set(gca,'Position',ax_pos-[0 0 0 10]);
%            set(gca,'Units',old_ax_units);
            %
            % setting up a legend
            %
            myleg = legend_fcn('Fluctuation tests',['cr. val. (' num2str(plobvalue,'%0.3f') ')'],1);
            setaxesfonts(myleg);
            set(gca,'UserData',myleg);
            toolbar_fcn(gca);
            hold('off');
            if curr_ini.external==0;
               plot_handles = [plot_handles myplot];
            else;
               file = [tm.outputdir 'tau-xi-' num2str(tm.r)];
               mstat = autosavefigure(myplot,file);
               stats = [stats mstat];
               file_names = strvcat(file_names,file);
            end;
         end;
      end;
      %
      % Display the Nyblom test
      %
      if tm.r<tm.n;
         if (curr_ini.nyblom==1)&(tm.q1+tm.q0==0)&(tm.datad==0);
            thispos = [thispos(1,1)+22 thispos(1,2)-22];
            if thispos(1,1)>(realscrsz(3)-550);
               thispos = [0 realscrsz(4)-430];
            end;
            if thispos(1,2)>(realscrsz(4)-430);
               thispos = [0 realscrsz(4)-430];
            elseif thispos(1,2)<32;
               thispos = [0 realscrsz(4)-430];
            end;
            myplot = figure('Units','pixels', ...
               'Position',[thispos 550 360], ...
               'NumberTitle','off', ...
               'Menubar','none', ...
               'Toolbar','none', ...
               'Visible','off', ...
               'Name',['Recursive Nyblom Statistic']);
            %
            % obey centering and filling defaults
            %
            setfigureproperties(myplot);
            %
            %
            % Setting up the plot
            %
            plot(dataindex(T1:tm.T,1),nyblomT','-','LineWidth',1,'Color',colorstr,'Tag','nyblom-statistics');
            %
            % add critical value when available
            %
            if tm.nyblom_asymp==1;
               cv_nyblom = nyblom_quantile(tm.n,tm.r,tm.cbs,'max',tm.deterselect);
               hold('on');
               plot([dataindex(T1,1) dataindex(tm.T,1)],cv_nyblom*ones(1,2),typestr,'LineWidth',1,'Color',colorstr2);
            end;
            set(gca,'XLim',[dataindex(T1,1) dataindex(tm.T,1)]);
            %
            % Fix YLim
            %
            if tm.nyblom_asymp==1;
               set(gca,'YLim',[0 max(max(nyblomT),cv_nyblom)+0.1]);
            else;
               set(gca,'YLim',[0 max(nyblomT)+0.1]);
            end;
            if tm.nyblom_asymp==1;
               setaxesfonts('Title',['Estimated Nyblom Q_{T}^{(t)} statistics with ' num2str(tm.cbs) ' % critical value for max test' textadd]);
               myleg = legend_fcn('Nyblom statistics',['cr. val. (' num2str(cv_nyblom,'%0.2f') ')'],1);
               setaxesfonts(myleg);
               set(gca,'UserData',myleg);
            else;
               setaxesfonts('Title',['Estimated Nyblom Q_{T}^{(t)} statistics' textadd]);
            end;
%            old_ax_units = get(gca,'Units');
%            set(gca,'Units','pixels');
%            ax_pos = get(gca,'Position');
%            set(gca,'Position',ax_pos-[0 0 0 10]);
%            set(gca,'Units',old_ax_units);
            toolbar_fcn(gca);
            hold('off');
            if curr_ini.external==0;
               plot_handles = [plot_handles myplot];
            else;
               file = [tm.outputdir 'nyblom-unrest-' num2str(tm.n) 'x' num2str(tm.r)];
               mstat = autosavefigure(myplot,file);
               stats = [stats mstat];
               file_names = strvcat(file_names,file);
            end;
         end;
      end;
      %
      % Display the largest non-unit eigenvalue of the companion matrix
      %
      if curr_ini.topeig==1;
         thispos = [thispos(1,1)+22 thispos(1,2)-22];
         if thispos(1,1)>(realscrsz(3)-550);
            thispos = [0 realscrsz(4)-430];
         end;
         if thispos(1,2)>(realscrsz(4)-430);
            thispos = [0 realscrsz(4)-430];
         elseif thispos(1,2)<32;
            thispos = [0 realscrsz(4)-430];
         end;
         myplot = figure('Units','pixels', ...
            'Position',[thispos 550 360], ...
            'NumberTitle','off', ...
            'Menubar','none', ...
            'Toolbar','none', ...
            'Visible','off', ...
            'Name',['Recursive Maximum Non-Unit Eigenvalue']);
         %
         % obey centering and filling defaults
         %
         setfigureproperties(myplot);
         %
         %
         % Setting up the plot
         %
         plot(dataindex(T1:tm.T,1),evaluet','-','LineWidth',1,'Color',colorstr,'Tag','max-eigenvalue-companion');
         hold('on');
         plot(dataindex(T1:tm.T,1),ones(size(dataindex(T1:tm.T,1),1),1),typestr,'LineWidth',1,'Color',colorstr2);
         set(gca,'XLim',[dataindex(T1,1) dataindex(tm.T,1)]);
         set(gca,'YLim',[0 max([max(evaluet) 1])+0.1]);
         setaxesfonts('Title',['Estimated maximum non-unit eigenvalue of the companion matrix' textadd]);
%         old_ax_units = get(gca,'Units');
%         set(gca,'Units','pixels');
%         ax_pos = get(gca,'Position');
%         set(gca,'Position',ax_pos-[0 0 0 10]);
%         set(gca,'Units',old_ax_units);
         toolbar_fcn(gca);
         hold('off');
         if curr_ini.external==0;
            plot_handles = [plot_handles myplot];
         else;
            file = [tm.outputdir 'max-companion-eig-unrest-rank.' num2str(tm.r)];
            mstat = autosavefigure(myplot,file);
            stats = [stats mstat];
            file_names = strvcat(file_names,file);
         end;
      end;
      if (curr_ini.external==1)&(isempty(stats)==0);
         for i=1:size(stats,2);
            if stats(i)==0;
               autoshowfigure(strtrim(file_names(i,:)));
            end;
         end;
      elseif curr_ini.external==0;
         for i=1:size(plot_handles,2);
            set(plot_handles(1,i),'Visible','on');
            drawnow;
         end;
      end;
   end;
else;
   txt = 'There are too few observations to estimate parameters recursively.';
   about(txt,'information','Recursions...',120,350);
   set(fig_handle,'Visible','on');
   drawnow;
end;

%
% end of show_recursiveeig.m
%
