function show_weakexo(fig_handle,beta,alpha,Sigma_theta,tm,curr_ini,ind,aind)

set(fig_handle,'Visible','off');
drawnow;
res_str = '';
if ind==1;
   res_str = ' restricted';
end;
realscrsz = get(0,'ScreenSize');
c_ind = 0;
if (isfield(tm,'restrict'))&(size(tm.restrict,2)==3);
   c_ind = tm.restrict(1,3);
end;
[results,degfree] = weakexotest(alpha,beta,tm.epsilon,tm.Z1,tm.Z2,tm.T-tm.df,aind,tm.modelsdir,tm.modelfile,Sigma_theta,c_ind,tm.Psi,tm.p,tm.pe,tm.d,tm.q1,tm.q0);
%
sp_str = spacestr(curr_ini.decimals-2);
prt_val = ['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f'];
weakstr = strvcat(' ',['WEAK EXOGENEITY TESTS (for' res_str ' rank=' num2str(tm.r) ')']);
numchar = size(weakstr,2);
addcorr = '';
for i=1:numchar;
   addcorr = strcat(addcorr,'=');
end;
weakstr = strvcat(weakstr,addcorr,' ');
weakstr = strvcat(weakstr,'  Wald-type test statistic','  ~~~~~~~~~~~~~~~~~~~~~~~~',' ');
weakstr = strvcat(weakstr,'Null hypothesis:        alpha in equation k is zero');
weakstr = strvcat(weakstr,'Alternative hypothesis: alpha in equation k is not zero',' ');
if curr_ini.sscorrect==0;
   weakstr = strvcat(weakstr,['Equation     df        W    ' sp_str '   p-value']);
   for i=1:tm.n;
      if degfree(i,1)>0;
         weakstr = strvcat(weakstr,sprintf([' %s%s  %2.0f    ' prt_val '      %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,degfree(i,1),results(i,1),results(i,2)));
      else;
         weakstr = strvcat(weakstr,[' ' tm.myvars(i,:) tm.mv2add '   Not computed']);
      end;
   end;
else;
   weakstr = strvcat(weakstr,['Equation        df          F    ' sp_str '    p-value']);
   for i=1:tm.n;
      if degfree(i,1)>0;
         weakstr = strvcat(weakstr,sprintf([' %s%s  (%2.0f,%3.0f)    ' prt_val '      %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,degfree(i,1),degfree(i,2),results(i,1),results(i,2)));
      else;
         weakstr = strvcat(weakstr,[' ' tm.myvars(i,:) tm.mv2add '   Not computed']);
      end;
   end;
end;
weakstr = strvcat(weakstr,' ');
textgui(weakstr,'Weak Exogeneity Tests',[(realscrsz(3)-680)/2 (realscrsz(4)-400)/2 680 400],'Results',38);
set(fig_handle,'Visible','on');
drawnow;


%
% end of show_weakexo.m
%
